// toShare index.js
///<reference path="ats/rest.js"/>
///<reference path="ats/tooltip.js"/>
'use strict';

async function initializePage(){
	await atsConfiguration.reflection();
	indexTitle();
	reservationMenu();
	inoutboardMenu();
	coHostInoutboardMenu();
}

function indexTitle(){
	const h1Tag = document.querySelector('h1');
	h1Tag.innerText = atsConfiguration.valueFromKey('Server name');
	document.title = h1Tag.innerText + ' - toShare'
}

function reservationMenu(){
	const divReservationTableSelect = document.getElementById('reservation-table-select');
	if(atsConfiguration.valueFromKey('reservation')!='false'){
		atsReservationTables.restGet().then(()=>{
			for(const atsTable of atsReservationTables.data){
				const aTag = document.createElement('a');
				aTag.href = (atsTable.table_custom === 0) ? '/reservation/' : '/custom/';
				aTag.href += atsTable.table_uri;
				aTag.innerText = atsTable.table_name;
				aTag.hash = atsTable.table_id;
				aTag.dataset.tooltip = atsTable.table_desc;

				const pTable = document.createElement('p');
				pTable.appendChild(aTag);

				divReservationTableSelect.appendChild(pTable);
			}
		});
	}else{document.getElementById('reservation').style.display='none'}
}

function inoutboardMenu(){
	const divInoutboardSelect = document.getElementById('inoutboard-select');
	if(atsConfiguration.valueFromKey('inoutboard')!='false'){
		atsInoutboards.restGet().then(()=>{
			if(atsInoutboards.data.length != 1){
				const details = document.createElement('details');
				details.innerHTML = '<summary>各掲示</summary>';
				divInoutboardSelect.appendChild(details);
				for(const atsInoutboard of atsInoutboards.data){
					const aTag = document.createElement('a');
					aTag.href = '/inoutboard/';
					aTag.innerHTML = '&#x25A0; ';
					aTag.innerText += atsInoutboard.board_name;
					aTag.dataset.tooltip = atsInoutboard.board_name;
					aTag.hash = atsInoutboard.board_id;

					const pTable = document.createElement('p');
					pTable.appendChild(aTag);

					details.appendChild(pTable);
				}
			}
		});
	}else{document.getElementById('inoutboard').style.display='none'}
}

function coHostInoutboardMenu(){
	const divInoutboardSelect = document.getElementById('co-host-select');
	if(atsConfiguration.valueFromKey('inoutboard')!='false'){
		atsCoHosts.restGet().then(()=>{
			if(atsCoHosts.data.length > 0){
				const details = document.createElement('details');
				details.innerHTML = '<summary>サーバー連携</summary>';
				divInoutboardSelect.appendChild(details);
				for(const atsHost of atsCoHosts.data){
					const aTag = document.createElement('a');
					aTag.href = '/co_hosts/inoutboard';
					aTag.innerHTML = '&#x27B0; ';
					aTag.innerText += atsHost.host_name;
					aTag.dataset.tooltip = atsHost.host_name;
					aTag.hash = atsHost.host_id;

					const pTable = document.createElement('p');
					pTable.appendChild(aTag);

					details.appendChild(pTable);
				}
			}
		});
	}else{document.getElementById('inoutboard').style.display='none'}
}

initializePage();
atsSleepDetector.addWakeListener(silentReload);
