// toShare inoutboard/kiosk.js
///<reference path="../ats/rest.js"/>
///<reference path="../ats/tooltip.js"/>
'use strict';

const boardId = Number(document.location.hash.substring(1));
const mainTag = document.querySelector('main');
const sectionInoutboardTemp = document.querySelector('section.inoutboard').cloneNode(true);
const trUserTemp = document.querySelector('section.inoutboard tbody tr').cloneNode(true);
const buttonUpdatePage = document.getElementById('update-page');
const spanCyclicEffective =  document.getElementById('cyclic-effective');
const divPeriodLayer = document.querySelector('div.period-layer');
const buttonUpdate = document.getElementById('update');
const buttonCyclic = document.getElementById('cyclic');
const buttonsingle = document.getElementById('single');
var intervalId = null;
sectionInoutboardTemp.querySelector('tbody').innerHTML = '';

async function initializaPage(){
	try{
		await atsInoutboards.restGet()
		await atsConfiguration.reflection();
		await atsConfiguration.loadInoutEditLayer();




		if(boardId !=0){
			const atsInoutboard = atsInoutboards.findField('board_id',boardId);
			const h1Tag = document.querySelector('h1');
			h1Tag.innerHTML = '&#x25A0; 行先掲示:';
			h1Tag.innerText +=  atsInoutboard.board_name;
			document.title = h1Tag.innerText + ' - toShare'
		}


		onButtonCyclicClick();



		attendanceUpdateLoad();
	}catch{
		location.href=location.origin;
	}
}

async function attendanceUpdateLoad(){
	await atsAttendance.restGet();
	const doubleBuffer = document.createElement('main');
	if(boardId !=0){
		const atsInoutboard = atsInoutboards.findField('board_id', boardId)
		doubleBuffer.appendChild(getSectionInoutboard(atsInoutboard))
	}else{
		for(const atsInoutboard of atsInoutboards.data){
			doubleBuffer.appendChild(getSectionInoutboard(atsInoutboard))
		}
	}

	mainTag.innerHTML = doubleBuffer.innerHTML;



	buttonUpdatePage.innerHTML = formatDate(new Date(), '&#x21BB;更新 (HH:mm)');
	highlight(buttonUpdatePage);
}

function getSectionInoutboard(atsInoutboard){
	const sectionInoutboard = sectionInoutboardTemp.cloneNode(true);
	sectionInoutboard.querySelector('caption').innerText = atsInoutboard.board_name;
	const inoutboardTbody = sectionInoutboard.querySelector('tbody');
	for(const atsUser of atsAttendance.data){
		if(atsInoutboard.board_id == atsUser.board_id){
			const trUser = trUserTemp.cloneNode(true);
			trUser.dataset.userId = atsUser.user_id;

			const td = trUser.querySelectorAll('td');
			td[0].innerText = atsUser.user_name;
			td[0].classList.add((atsUser.clock_status)? 'clock-in': 'clock-out');
			td[1].innerText = atsUser.whereabouts;
			td[2].innerText = atsUser.description;

			inoutboardTbody.appendChild(trUser);
		}
	}
	return sectionInoutboard;
}









function openPeriodWindow(){
	divPeriodLayer.style.display = 'flex';
}
function closePeriodWindow(){
	divPeriodLayer.style.display = 'none';
}
function onOutsideClick(event){
	if(event.currentTarget == event.target)closePeriodWindow();
}

function onButtonUpdateClick(){
	attendanceUpdateLoad();
	closePeriodWindow();
}
function onButtonCyclicClick(){
	if(!intervalId)
		intervalId = setInterval(attendanceUpdateLoad, 1000*60*5);
	closePeriodWindow();
	spanCyclicEffective.style.display = 'inline';

}







function onWakeup(){


	attendanceUpdateLoad();

}
buttonUpdatePage.addEventListener('click', openPeriodWindow);
divPeriodLayer.addEventListener('click', onOutsideClick);
buttonUpdate.addEventListener('click', onButtonUpdateClick);



initializaPage();
atsSleepDetector.addWakeListener(onWakeup);
