// toShare dd.js
///<reference path="../ats/rest.js"/>
///<reference path="../ats/reservation.js"/>
'use strict';

class ddReservationsClass extends reservations {
	// tbody
	updateReservations(tbody){
		super.updateReservations(tbody);
		tbody.addEventListener('click', ddEdit.onTBodyClick);
	}
	// thead th
	updateTheadTh(theadDate, colGroupCol, theadTh){
		super.updateTheadTh(theadDate, colGroupCol, theadTh);
		theadTh.innerText = ((theadDate.getDate()===1) ? formatDate(theadDate, 'yyyy\nM/') : '') 
			+ formatDate(theadDate, 'd');
		theadTh.dataset.tooltip = formatDate(theadDate, 'yyyy/MM/dd');
		theadTh.addEventListener('click', ddTodayView.onTheadThClick);
	}
	// tbody th
	updateTbodyTh(atsItem, tbodyTh){
		super.updateTbodyTh(atsItem, tbodyTh);
		tbodyTh.dataset.tooltip = atsItems.findField('item_id', Number(tbodyTh.dataset.itemId)).item_desc;
		tbodyTh.addEventListener('click', ddEdit.onTbodyThClick);
	}
	// tbody td p
	updateTbodyData(reservationItem, tbodyP){
		const reservationStartDate = new Date(reservationItem.start_datetime);
		const reservationEndDate = new Date(reservationItem.end_datetime);
		tbodyP.innerText = reservationItem.reservation_desc + '\n'
			+ reservationItem.user_name + '\n'
			+ formatDate(reservationStartDate, 'yyyy/MM/dd から\n')
			+ formatDate(reservationEndDate, 'yyyy/MM/dd まで');
		tbodyP.dataset.tooltip = '';
		tbodyP.addEventListener('click', ddEdit.onTbodyDataClick);
	}
	
	async updateLoad(){
		await super.updateLoad();
		ddEdit.tableSelectUpdate();
	}
}

const ddReservations = new ddReservationsClass;
const ddEdit = new reservationEdit(ddReservations, MINIMUM_UNIT_DATE);
const ddTodayView = new todayView(ddReservations, ddEdit, MINIMUM_UNIT_DATE);

initializePage(ddReservations, ddEdit, BULK_RESERVATION);

