// toShare dt.js
///<reference path="../ats/rest.js"/>
///<reference path="../ats/reservation.js"/>
'use strict';

class dtReservationsClass extends reservations {
	// tbody (Override. Click on white space on the reservation list to deselect.)
	updateReservations(tbody){
		super.updateReservations(tbody);
		tbody.addEventListener('click', dtEdit.onTBodyClick);
	}
	// thead th (Override. Click on table date to open todayview)
	updateTheadTh(theadDate, colGroupCol, theadTh){
		super.updateTheadTh(theadDate, colGroupCol, theadTh);


		theadTh.dataset.tooltip = formatDate(theadDate, 'yyyy/MM/dd');
		theadTh.addEventListener('click', dtTodayView.onTheadThClick);
	}
	// tbody th (Override. Start editing. Switch item selection state)
	updateTbodyTh(atsItem, tbodyTh){
		super.updateTbodyTh(atsItem, tbodyTh);
		tbodyTh.dataset.tooltip = atsItem.item_desc;
		tbodyTh.addEventListener('click', dtEdit.onTbodyThClick);
	}
	// tbody td p (Override. Editing status change by data click)
	updateTbodyData(reservationItem, tbodyP){
		super.updateTbodyData(reservationItem, tbodyP);




		
		tbodyP.dataset.tooltip = '';
		tbodyP.addEventListener('click', dtEdit.onTbodyDataClick);
	}
	// table (Override. Selection state synchronization)
	async updateLoad(){
		await super.updateLoad();
		dtEdit.tableSelectUpdate();
	}
}

const dtReservations = new dtReservationsClass;
const dtEdit = new reservationEdit(dtReservations, MINIMUM_UNIT_TIME);
const dtTodayView = new todayView(dtReservations, dtEdit, MINIMUM_UNIT_TIME);

initializePage(dtReservations, dtEdit, BULK_RESERVATION);
